import { getCurrentInstance as rt, inject as ct, markRaw as O, ref as Y, watch as it, reactive as at, effectScope as ut, isRef as w, isReactive as H, toRef as L, toRaw as ft, nextTick as W, computed as Z, getCurrentScope as lt, onScopeDispose as ht, toRefs as q } from "vue";
var pt = !1;
function C(t, r, o) {
  return Array.isArray(t) ? (t.length = Math.max(t.length, r), t.splice(r, 1, o), o) : (t[r] = o, o);
}
function R(t, r) {
  if (Array.isArray(t)) {
    t.splice(r, 1);
    return;
  }
  delete t[r];
}
/*!
  * pinia v2.0.34
  * (c) 2023 Eduardo San Martin Morote
  * @license MIT
  */
let j;
const I = (t) => j = t, _t = process.env.NODE_ENV !== "production" ? Symbol("pinia") : (
  /* istanbul ignore next */
  Symbol()
);
function m(t) {
  return t && typeof t == "object" && Object.prototype.toString.call(t) === "[object Object]" && typeof t.toJSON != "function";
}
var F;
(function(t) {
  t.direct = "direct", t.patchObject = "patch object", t.patchFunction = "patch function";
})(F || (F = {}));
const T = typeof window < "u", x = (process.env.NODE_ENV !== "production" || typeof __VUE_PROD_DEVTOOLS__ < "u" && __VUE_PROD_DEVTOOLS__) && process.env.NODE_ENV !== "test" && T;
function K(t, r) {
  for (const o in r) {
    const s = r[o];
    if (!(o in t))
      continue;
    const i = t[o];
    m(i) && m(s) && !w(s) && !H(s) ? t[o] = K(i, s) : t[o] = s;
  }
  return t;
}
const tt = () => {
};
function z(t, r, o, s = tt) {
  t.push(r);
  const i = () => {
    const a = t.indexOf(r);
    a > -1 && (t.splice(a, 1), s());
  };
  return !o && lt() && ht(i), i;
}
function D(t, ...r) {
  t.slice().forEach((o) => {
    o(...r);
  });
}
function A(t, r) {
  t instanceof Map && r instanceof Map && r.forEach((o, s) => t.set(s, o)), t instanceof Set && r instanceof Set && r.forEach(t.add, t);
  for (const o in r) {
    if (!r.hasOwnProperty(o))
      continue;
    const s = r[o], i = t[o];
    m(i) && m(s) && t.hasOwnProperty(o) && !w(s) && !H(s) ? t[o] = A(i, s) : t[o] = s;
  }
  return t;
}
const dt = process.env.NODE_ENV !== "production" ? Symbol("pinia:skipHydration") : (
  /* istanbul ignore next */
  Symbol()
);
function Et(t) {
  return !m(t) || !t.hasOwnProperty(dt);
}
const { assign: v } = Object;
function Q(t) {
  return !!(w(t) && t.effect);
}
function X(t, r, o, s) {
  const { state: i, actions: a, getters: l } = r, f = o.state.value[t];
  let b;
  function h() {
    !f && (process.env.NODE_ENV === "production" || !s) && (o.state.value[t] = i ? i() : {});
    const d = process.env.NODE_ENV !== "production" && s ? (
      // use ref() to unwrap refs inside state TODO: check if this is still necessary
      q(Y(i ? i() : {}).value)
    ) : q(o.state.value[t]);
    return v(d, a, Object.keys(l || {}).reduce((p, E) => (process.env.NODE_ENV !== "production" && E in d && console.warn(`[🍍]: A getter cannot have the same name as another state property. Rename one of them. Found with "${E}" in store "${t}".`), p[E] = O(Z(() => {
      I(o);
      const N = o._s.get(t);
      return l[E].call(N, N);
    })), p), {}));
  }
  return b = U(t, h, r, o, s, !0), b;
}
function U(t, r, o = {}, s, i, a) {
  let l;
  const f = v({ actions: {} }, o);
  if (process.env.NODE_ENV !== "production" && !s._e.active)
    throw new Error("Pinia destroyed");
  const b = {
    deep: !0
    // flush: 'post',
  };
  process.env.NODE_ENV !== "production" && !pt && (b.onTrigger = (n) => {
    h ? N = n : h == !1 && !c._hotUpdating && (Array.isArray(N) ? N.push(n) : console.error("🍍 debuggerEvents should be an array. This is most likely an internal Pinia bug."));
  });
  let h, d, p = O([]), E = O([]), N;
  const P = s.state.value[t];
  !a && !P && (process.env.NODE_ENV === "production" || !i) && (s.state.value[t] = {});
  const k = Y({});
  let B;
  function G(n) {
    let e;
    h = d = !1, process.env.NODE_ENV !== "production" && (N = []), typeof n == "function" ? (n(s.state.value[t]), e = {
      type: F.patchFunction,
      storeId: t,
      events: N
    }) : (A(s.state.value[t], n), e = {
      type: F.patchObject,
      payload: n,
      storeId: t,
      events: N
    });
    const u = B = Symbol();
    W().then(() => {
      B === u && (h = !0);
    }), d = !0, D(p, e, s.state.value[t]);
  }
  const et = a ? function() {
    const { state: e } = o, u = e ? e() : {};
    this.$patch((_) => {
      v(_, u);
    });
  } : (
    /* istanbul ignore next */
    process.env.NODE_ENV !== "production" ? () => {
      throw new Error(`🍍: Store "${t}" is built using the setup syntax and does not implement $reset().`);
    } : tt
  );
  function st() {
    l.stop(), p = [], E = [], s._s.delete(t);
  }
  function J(n, e) {
    return function() {
      I(s);
      const u = Array.from(arguments), _ = [], V = [];
      function ot(y) {
        _.push(y);
      }
      function nt(y) {
        V.push(y);
      }
      D(E, {
        args: u,
        name: n,
        store: c,
        after: ot,
        onError: nt
      });
      let S;
      try {
        S = e.apply(this && this.$id === t ? this : c, u);
      } catch (y) {
        throw D(V, y), y;
      }
      return S instanceof Promise ? S.then((y) => (D(_, y), y)).catch((y) => (D(V, y), Promise.reject(y))) : (D(_, S), S);
    };
  }
  const $ = /* @__PURE__ */ O({
    actions: {},
    getters: {},
    state: [],
    hotState: k
  }), M = {
    _p: s,
    // _s: scope,
    $id: t,
    $onAction: z.bind(null, E),
    $patch: G,
    $reset: et,
    $subscribe(n, e = {}) {
      const u = z(p, n, e.detached, () => _()), _ = l.run(() => it(() => s.state.value[t], (V) => {
        (e.flush === "sync" ? d : h) && n({
          storeId: t,
          type: F.direct,
          events: N
        }, V);
      }, v({}, b, e)));
      return u;
    },
    $dispose: st
  }, c = at(process.env.NODE_ENV !== "production" || x ? v(
    {
      _hmrPayload: $,
      _customProperties: O(/* @__PURE__ */ new Set())
      // devtools custom properties
    },
    M
    // must be added later
    // setupStore
  ) : M);
  s._s.set(t, c);
  const g = s._e.run(() => (l = ut(), l.run(() => r())));
  for (const n in g) {
    const e = g[n];
    if (w(e) && !Q(e) || H(e))
      process.env.NODE_ENV !== "production" && i ? C(k.value, n, L(g, n)) : a || (P && Et(e) && (w(e) ? e.value = P[n] : A(e, P[n])), s.state.value[t][n] = e), process.env.NODE_ENV !== "production" && $.state.push(n);
    else if (typeof e == "function") {
      const u = process.env.NODE_ENV !== "production" && i ? e : J(n, e);
      g[n] = u, process.env.NODE_ENV !== "production" && ($.actions[n] = e), f.actions[n] = e;
    } else
      process.env.NODE_ENV !== "production" && Q(e) && ($.getters[n] = a ? (
        // @ts-expect-error
        o.getters[n]
      ) : e, T && (g._getters || // @ts-expect-error: same
      (g._getters = O([]))).push(n));
  }
  if (v(c, g), v(ft(c), g), Object.defineProperty(c, "$state", {
    get: () => process.env.NODE_ENV !== "production" && i ? k.value : s.state.value[t],
    set: (n) => {
      if (process.env.NODE_ENV !== "production" && i)
        throw new Error("cannot set hotState");
      G((e) => {
        v(e, n);
      });
    }
  }), process.env.NODE_ENV !== "production" && (c._hotUpdate = O((n) => {
    c._hotUpdating = !0, n._hmrPayload.state.forEach((e) => {
      if (e in c.$state) {
        const u = n.$state[e], _ = c.$state[e];
        typeof u == "object" && m(u) && m(_) ? K(u, _) : n.$state[e] = _;
      }
      C(c, e, L(n.$state, e));
    }), Object.keys(c.$state).forEach((e) => {
      e in n.$state || R(c, e);
    }), h = !1, d = !1, s.state.value[t] = L(n._hmrPayload, "hotState"), d = !0, W().then(() => {
      h = !0;
    });
    for (const e in n._hmrPayload.actions) {
      const u = n[e];
      C(c, e, J(e, u));
    }
    for (const e in n._hmrPayload.getters) {
      const u = n._hmrPayload.getters[e], _ = a ? (
        // special handling of options api
        Z(() => (I(s), u.call(c, c)))
      ) : u;
      C(c, e, _);
    }
    Object.keys(c._hmrPayload.getters).forEach((e) => {
      e in n._hmrPayload.getters || R(c, e);
    }), Object.keys(c._hmrPayload.actions).forEach((e) => {
      e in n._hmrPayload.actions || R(c, e);
    }), c._hmrPayload = n._hmrPayload, c._getters = n._getters, c._hotUpdating = !1;
  })), x) {
    const n = {
      writable: !0,
      configurable: !0,
      // avoid warning on devtools trying to display this property
      enumerable: !1
    };
    ["_p", "_hmrPayload", "_getters", "_customProperties"].forEach((e) => {
      Object.defineProperty(c, e, v({ value: c[e] }, n));
    });
  }
  return s._p.forEach((n) => {
    if (x) {
      const e = l.run(() => n({
        store: c,
        app: s._a,
        pinia: s,
        options: f
      }));
      Object.keys(e || {}).forEach((u) => c._customProperties.add(u)), v(c, e);
    } else
      v(c, l.run(() => n({
        store: c,
        app: s._a,
        pinia: s,
        options: f
      })));
  }), process.env.NODE_ENV !== "production" && c.$state && typeof c.$state == "object" && typeof c.$state.constructor == "function" && !c.$state.constructor.toString().includes("[native code]") && console.warn(`[🍍]: The "state" must be a plain object. It cannot be
	state: () => new MyClass()
Found in store "${c.$id}".`), P && a && o.hydrate && o.hydrate(c.$state, P), h = !0, d = !0, c;
}
function yt(t, r, o) {
  let s, i;
  const a = typeof r == "function";
  typeof t == "string" ? (s = t, i = a ? o : r) : (i = t, s = t.id);
  function l(f, b) {
    const h = rt();
    if (f = // in test mode, ignore the argument provided as we can always retrieve a
    // pinia instance with getActivePinia()
    (process.env.NODE_ENV === "test" && j && j._testing ? null : f) || h && ct(_t, null), f && I(f), process.env.NODE_ENV !== "production" && !j)
      throw new Error(`[🍍]: getActivePinia was called with no active Pinia. Did you forget to install pinia?
	const pinia = createPinia()
	app.use(pinia)
This will fail in production.`);
    f = j, f._s.has(s) || (a ? U(s, r, i, f) : X(s, i, f), process.env.NODE_ENV !== "production" && (l._pinia = f));
    const d = f._s.get(s);
    if (process.env.NODE_ENV !== "production" && b) {
      const p = "__hot:" + s, E = a ? U(p, r, i, f, !0) : X(p, v({}, i), f, !0);
      b._hotUpdate(E), delete f.state.value[p], f._s.delete(p);
    }
    if (process.env.NODE_ENV !== "production" && T && h && h.proxy && // avoid adding stores that are just built for hot module replacement
    !b) {
      const p = h.proxy, E = "_pStores" in p ? p._pStores : p._pStores = {};
      E[s] = d;
    }
    return d;
  }
  return l.$id = s, l;
}
const vt = yt("fetchingGlobalStore", {
  state: () => ({
    states: {}
  }),
  getters: {},
  actions: {
    setFetchingInit(t, r, o) {
      this.states[t] = {
        key: t,
        onFetching: r,
        isFetching: o
      };
    },
    setCurrentKeyData(t, r, o) {
      var s;
      (s = this.states[t]) != null && s.key ? (this.states[t] = {
        ...this.states[t],
        data: r,
        status: o
      }, this.broadcastFetching()) : console.warn("key is no exist!");
    },
    broadcastFetching() {
      var t;
      for (const r in this.states)
        if (Object.prototype.hasOwnProperty.call(this.states, r)) {
          const o = this.states[r];
          (t = o.onFetching) == null || t.call(o, o, this.states), o.isFetching && this.isFetchingAll(o.isFetching);
        }
    },
    isFetchingAll(t) {
      const r = Object.keys(this.states), o = Object.keys(this.states).filter(
        (s) => this.states[s].status === "success"
      );
      t(r.length === o.length);
    }
  }
}), bt = (t, { fetchingKey: r, onFetching: o, isFetching: s }) => {
  const i = vt();
  let a;
  return {
    onBefore: (l) => {
      a = r == null ? void 0 : r(l), a && i.setFetchingInit(a, o, s);
    },
    onSuccess: (l) => {
      a && i.setCurrentKeyData(a, l, "success");
    },
    onError: () => {
      a && i.setCurrentKeyData(a, null, "error");
    }
  };
};
export {
  bt as useFetchingPlugin
};
